#include <bits/stdc++.h>
using namespace std;

#define rep(i,a,b) for(int i=a;i<(b);++i)
#define all(x) begin(x), end(x)
#define sz(x) (int)(x).size()
typedef long long ll;
typedef pair<int,int> pii;
typedef vector<int> vi;
typedef long double ld;

#define pb push_back
#define ff first
#define ss second
typedef vector<bitset<512>> vb;
struct Maxclique {
	double limit = 0.025, pk = 0;
	struct Vertex {int i, d = 0;};
	typedef vector<Vertex> vv;
	vb e;
	vv V;
	vector<vi> C;
	vi qmax, q, S, old;
	void init(vv& r){
		for (auto& v : r) v.d = 0;
		for(auto& v : r) for(auto j : r) v.d+= e[v.i][j.i];
		sort(all(r), [](auto a, auto b) {return a.d > b.d;});
		int mxD = r[0].d;
		rep(i, 0, sz(r)) r[i].d = min(i, mxD) + 1;
	}
	void expand(vv& R, int lev = 1){
		cout << lev << endl;
		S[lev]+= S[lev-1] - old[lev];
		old[lev] = S[lev-1];
		while(sz(R)){
			if (sz(q) + R.back().d <= sz(qmax)) return;
			q.pb(R.back().i);
			vv T;
			for(auto v:R) if(e[R.back().i][v.i]) T.pb({v.i});
			if(sz(T)) {
				if(S[lev]++ / ++pk < limit) init(T);
				int j = 0, mxk = 1, mnk = max(sz(qmax) - sz(q) + 1, 1);
				C[1].clear(), C[2].clear();
				for(auto v : T){
					int k = 1;
					auto f = [&](int i) {return e[v.i][i];};
					while(any_of(all(C[k]), f)) k++;
					if(k > mxk) mxk = k, C[mxk + 1].clear();
					if(k < mnk) T[j++].i = v.i;
					C[k].pb(v.i);
				}
				if(j > 0) T[j-1].d = 0;
				rep(k, mnk, mxk+1) for(int i : C[k])
					T[j].i = i, T[j++].d = k;
				expand(T, lev+1);
			} else if(sz(q) > sz(qmax)) qmax = q;
			q.pop_back(), R.pop_back();
		}
	}
	vi maxClique() {init(V), expand(V); return qmax;}
	Maxclique(vb conn) : e(conn), C(sz(e) + 1), S(sz(C)), old(S) {
		rep(i, 0, sz(e)) V.pb({i});
	}
};

vb adj;
ll n;

ll tol(ll x, ll y){
	return x*n + y;
}

pair<ll, ll> top(ll l){
	return {l / n, l % n};
}

void solve(){
	ld r;
	cin >> n >> r;
	adj.resize(512);
	for(ll i = 0; i < n*n; ++i) for(ll j = 0; j < n*n; ++j){
		adj[i][j] = 1;
		adj[j][i] = 1;
	}
	for(ll i = 0; i < n*n; ++i) for(ll j = 0; j < n*n; ++j){
		auto[x1, y1] = top(i);
		auto[x2, y2] = top(j);
		ll dx = abs(x1 - x2), dy = abs(y1 - y2);
		if(dx*dx + dy*dy <= 4.0L*r*r)
			continue;
		adj[i][j] = 0;
		adj[j][i] = 0;
	}
	Maxclique mc(adj);
	vi vp = mc.maxClique();
	cout << vp.size() << "\n";
	for(ll pp : vp){
		auto[x, y] = top(pp);
		cout << x+1 << " " << y+1 << "\n";
	}
}

int main(){
	cin.tie(0);
	ios_base::sync_with_stdio(0);
	cout<<fixed<<setprecision(12);
	
	solve();
	
}
