#include <bits/stdc++.h>
using namespace std;

#define rep(i,a,b) for(int i=a;i<(b);++i)
#define all(x) begin(x), end(x)
#define sz(x) (int)(x).size()
typedef long long ll;
typedef pair<int,int> pii;
typedef vector<int> vi;

#define pb push_back
#define ff first
#define ss second

void solve(){
	ll n;
	cin >> n;
	vector<set<ll>> adj(n);
	for(ll i = 0; i < n-1; ++i){
		ll u, v;
		cin >> u >> v;
		u--; v--;
		adj[u].insert(v);
		adj[v].insert(u);
	}
	vector<ll> ct(n, 1);
	priority_queue<pair<ll, ll>> q;
	set<ll> act;
	for(ll i = 0; i < n; ++i){
		act.insert(i);
		if(adj[i].size() == 1)
			q.push({-ct[i], i});
	}
	
	while(!q.empty()){
		auto[prio, nd] = q.top();
		q.pop();
		if(act.find(nd) == act.end())
			continue;
		ll pr = *adj[nd].begin();
		if(ct[nd] > ct[pr])
			continue;
		ct[pr] += ct[nd];
		adj[pr].erase(nd);
		if(adj[pr].size() == 1){
			q.push({-ct[pr], pr});
		}
		act.erase(nd);
	}
	if(act.size() <= 1){
		cout << "YES\n";
	}else{
		cout << "NO\n";
	}
}

int main(){
	cin.tie(0);
	ios_base::sync_with_stdio(0);
	cout<<fixed<<setprecision(12);
	
	solve();
	
	
	
}

